<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <!-- <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item> -->
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" size="mini" @click="handleAdd" v-hasPermi="['manage:dataDown:add']">数据下载</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataDownList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="指令" align="center" prop="order" />
      <el-table-column label="下载的数据名称" align="center" prop="name" />
      <el-table-column label="保存路径" align="center" prop="path" />
      <el-table-column label="备注" align="center" prop="remark" />
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改数据下载对话框 -->
    <el-dialog :title="title" :visible.sync="open" :close-on-click-modal="false" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="指令" prop="order">
          <el-select v-model="form.order" placeholder="请选择指令" style="width:100%">
            <el-option
              v-for="item in instructionInfoList"
              :key="item.attribute"
              :label="item.attribute"
              :value="item.attribute">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :loading="butLoading">{{
          butText
        }}</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listDataDown,
  getDataDown,
  delDataDown,
  addDataDown,
  updateDataDown,
} from "@/api/manage/dataDown";
import { listInstructionInfo } from "@/api/manage/instructionInfo";

export default {
  name: "DataDown",
  data() {
    return {
      index: 1,
      // 遮罩层
      loading: true,
      // 按钮加载
      butLoading: false,
      // 按钮显示文本
      butText: "点击下载",
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 数据下载表格数据
      dataDownList: [],
      // 弹出层标题
      title: "",
      // 指令西信息
      instructionInfoList: [],
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        order: null,
        name: null,
        path: null,
        remark: null,
        type: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      },
      // 表单参数
      form: {
        type: ".xlsx",
        path: "/phm/uploadPath",
      },
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getList();
    this.getListInstructionInfo();
  },
  methods: {
    // 获取指令
    getListInstructionInfo() {
      let queryParams = {
        pageNum: 1,
        pageSize: 1000,
        attribute: null,
        content: null,
      }
      listInstructionInfo(queryParams).then(response => {
        this.instructionInfoList = response.rows;
      });
    },
    /** 查询数据下载列表 */
    getList() {
      this.loading = true;
      // listDataDown(this.queryParams).then(response => {
      //   this.dataDownList = response.rows;
      //   this.total = response.total;
      //   this.loading = false;
      // });
      this.dataDownList = JSON.parse(localStorage.getItem("data-down")) || [];
      this.total = this.dataDownList?.length || 0;
      this.loading = false;
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        order: null,
        remark: null
      }
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "下载指令信息确定";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getDataDown(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改数据下载";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.butLoading = true;
      this.butText = "下载中";
      setTimeout(() => {
        // 方法区
        if (this.form.order === "error") {
          this.$modal.msgError("下载异常");
          this.butLoading = false;
          this.butText = "点击下载";
          return;
        }
        // 服务获取文件
        let dataObj = {
          order: this.form.order,
          name: `固定格式_${new Date().getTime()}.xlsx`,
          path: "/phm/uploadPath",
          remark: this.form.remark,
        };
        let data = JSON.parse(localStorage.getItem("data-down")) || [];
        data.push(dataObj);
        localStorage.setItem("data-down", JSON.stringify(data));
        this.getList();
        // 保存指定路径
        this.butLoading = false;
        this.butText = "点击下载";
        this.$modal.msgSuccess("下载成功");
        this.open = false;
      }, 1000);
      // this.$refs["form"].validate(valid => {
      //   if (valid) {
      //     if (this.form.id != null) {
      //       updateDataDown(this.form).then(response => {
      //         this.$modal.msgSuccess("修改成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     } else {
      //       addDataDown(this.form).then(response => {
      //         this.$modal.msgSuccess("新增成功");
      //         this.open = false;
      //         this.getList();
      //       });
      //     }
      //   }
      // });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除数据下载编号为"' + ids + '"的数据项？')
        .then(function () {
          return delDataDown(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "manage/dataDown/export",
        {
          ...this.queryParams,
        },
        `dataDown_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
